      SUBROUTINE MNI1R (N,X,A,B,M,L,F,FUN,G,GRAD,UP,I0,RM,IW,MNI)
      DIMENSION X(N),A(N),B(N),F(L),G(N),UP(1),I0(1),RM(1)
      REAL MP,MG
      REAL X,A,B,F,G,UP,RM,FZ,EG,EX,E,EGR,E2,STEP,GAMMA,
     *TETA,TET,FS,FX,R1,R2,R3,R4,T,E1
      INTEGER I0,IW,N,M,L,NU,IWS,IU,IE,KIT,N1,IWD,NF,NG,M1,NI,
     *KMAX,NP,KP,K1,K2,K3,K4,K5,K6,K7,I,MG1,MP1,K5I,K7I,K4I,NIT
      EXTERNAL MNI
      COMMON /MNI1/ TETA, TET,E,NF,NG,M1,NU
      COMMON /MNI2/ EX,EG,EGR,E2,STEP,MG,MP,IU,IWS,IE,KIT,GAMMA,N1,IWD
      NU=UP(15)
      FZ=1.E+18
      IF(L.GT.1) GOTO 1
      IWS=134
      EG=UP(8)
      EX=UP(7)
      GO TO 2
    1 E=UP(2)
      EGR=UP(11)
      EX=UP(12)
      EG=UP(13)
      IWD=1
      IWS=1
      TETA=UP(1)
      TET=TETA-1.
      E2=10.
    2 NI=0
      NF=0
      NG=0
      IW=0
      IU=UP(4)
      KIT=UP(5)
      KMAX=UP(14)
      NP=UP(9)
      KP=UP(10)
      STEP=1
      K1=2*N+1
      K2=N**2+2*N+1
      K3=2*N**2+2*N+1
      K4=K3+5*N-1
      K5=K3+6*N-1
      K6=K3+7*N
      K7=K3+N-1
      N1=N-1
      M1=M+1
      GAMMA=1.E-10
      CALL MNI20(FUN,N,M,L,X,FX,F,FS)
    4 CALL MNI25(GRAD,N,M,L,X,F,G,I0,RM(K4+1))
    5 DO 10 I=1,N
      K4I=K4+I
      K5I=K5+I
   10 G(I)=RM(K4I)+E*RM(K5I)
      CALL MNR1N(G,N,MG)
      FX=F(1)+E*FS
   15 IE=0
   16 DO 18 I=1,N
      IF(X(I).LT.A(I)+EX.AND.G(I).GT.0) G(I)=0
      IF(X(I).GT.B(I)-EX.AND.G(I).LT.0) G(I)=0
   18 CONTINUE
      CALL MNR1N(G,N,MP)
      IF(NP.NE.0.OR.KP.EQ.0.OR.NI.NE.0) GO TO 20
      CALL MNI30 (N,M,L,NI,X,FX,F)
   20 IF(MP.LE.GAMMA) GO TO 77
   21 IF(NI.GE.KMAX) GO TO 85
      IWD=IWS
      NI=NI+1
      CALL MNI10 (FUN,GRAD,N,M,L,A,B,X,FX,
     *F,FS,G,I0,RM(K1),RM(K2),RM(K3),RM(K6),MNI)
      IF(NI.LT.NP.OR.KP.EQ.0.OR.MOD(NI-NP,KP).NE.0) GO TO 22
      CALL MNI30 (N,M,L,NI,X,FX,F)
   22 IF(IWS.EQ.9) GO TO 90
      IF(L.GT.1.OR.IWS.NE.4) GO TO 35
      IWS=134
      GO TO 21
   35 IF(IWS.EQ.13) GO TO 70
      IF(IWS.EQ.5) GO TO 77
      IF(IWS.EQ.4) GO TO 45
      IF(FS.LE.EGR) GO TO 37
   36 IF(KIT.EQ.1) EX=STEP*0.1
      E=E*UP(3)
      GO TO 5
   37 DO 38 I=1,N
   38 RM(I)=X(I)
   40 FZ=FX
      KIT=UP(5)
      IWS=134
      GO TO 21
   45 IF(FZ.GE.FX) GO TO 50
      E2=AMAX1(E2/2.,1.)
      DO 46 I=1,N
      X(I)=RM(I)
      NIT=N+I
   46 G(I)=RM(NIT)
      FX=FZ
      MG=MG1
      MP=MP1
      IWS=134
      GOTO 21
   50 DO 52 I=1,N
      K4I=K4+I
      K7I=K7+I
      RM(K7I)=RM(K4I)
      NIT=N+I
      RM(NIT)=X(I)-RM(I)
      IF(X(I).GT.A(I)+EX) GO TO 51
      K4I=K4+I
      K7I=K7+I
      IF(RM(K4I).GT.0) RM(K7I)=0
      NIT=N+I
      IF(X(I).LT.RM(I)) RM(NIT)=0.
   51 IF(X(I).LT.B(I)-EX) GO TO 52
      K7I=K7+I
      K4I=K4+I
      IF(RM(K4I).LT.0) RM(K7I)=0
      NIT=N+I
      IF(X(I).GT.RM(I)) RM(NIT)=0.
   52 CONTINUE
      CALL MNR1N(RM(N+1),N,R1)
      CALL MNR1N(RM(K7+1),N,R2)
      T=0.
      IF(R2.LE.GAMMA) GO TO 37
   54 DO 55 I=1,N
      NIT=N+I
      K7I=K7+I
   55 RM(I)=RM(NIT)*(1-T)/R1-T*RM(K7I)/R2
      CALL MNR1N(RM(1),N,R4)
      IF(R4.LE.GAMMA) GO TO 57
      CALL MNR1S(RM(K7+1),RM(1),N,R3)
      R3=R3/R4
      IF(R3+GAMMA.LT.0) GO TO 60
   57 T=T+0.1
      GO TO 54
   60 DO 65 I=1,N
      K7I=K7+I
      RM(K7I)=RM(I)/R4
      NIT=N+I
      RM(NIT)=G(I)
   65 RM(I)=X(I)
      FZ=FX
      MP1=MP
      MG1=MG
      FX=F(1)
      IWS=4
      E1=E
      E=0
      STEP=AMAX1(EGR,STEP)
      CALL MNI(FUN,A,B,N,M,L,RM(1),FX,F,FS,X,RM(K7+1),R3,RM(K6))
      E=E1
      KIT=UP(5)
      IWS=134
      GO TO 4
   70 IF(FS.LE.UP(6).AND.STEP.LE.UP(7)) GO TO 76
      IF(FS.LE.UP(6)) GO TO 75
   73 IWS=1
      E=E*UP(3)
      E2=10.
      EGR=AMIN1(1.,FS)*0.1
      GO TO 5
   75 IWS=134
      KIT=UP(5)
      EX=AMAX1(STEP*0.1,UP(7))
      GOTO 16
   76 IF(MP.LE.UP(8)) GO TO 80
      EG=AMAX1(MP*0.1,UP(8))
      GO TO 40
   77 IF(FS.GT.UP(6)) GO TO 78
      GO TO 80
   78 IF(IWD.EQ.134) GO TO 73
      IWS=1
      GOTO 36
   80 IW=1
      GO TO 90
   85 IW=4
   90 DO 95 I=1,N
      K4I=K4+I
   95 G(I)=RM(K4I)
      IF(KP.EQ.0.OR.(NI.GE.NP.AND.MOD(NI-NP,KP).EQ.0)) GO TO 100
      CALL MNI30 (N,M,L,NI,X,FX,F)
  100 RM(1)=NI
      RM(2)=NF
      RM(3)=NG
      RETURN
      END
